image: maven:latest

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"
  DOCKER_HOST: tcp://docker:2375 
  IMAGE_NAME: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG 
  IMAGE_TAG: ${CI_COMMIT_REF_SLUG}
cache:
  paths:
    - .m2/repository/
    - target/
    
build:
  stage: build
  script:
    - mvn compile
    
test:
  stage: test
  script:
    - mvn test

release:
    image: docker:git
    services:
      - docker:dind
    variables:
      DOCKER_DRIVER: overlay 
      stage: release 
    before_script: 
      - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY 
    script: 
      - docker build --tag=$IMAGE_TAG . --pull -t $IMAGE_NAME 
      - docker push $IMAGE_NAME 
    only: 
      - master